var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _Messaging_native, _Messaging_app, _Messaging_onMessage, _Messaging_onNotificationTap, _Messaging_onToken, _Messaging_instance;
import { Utils } from '@nativescript/core';
import { FirebaseApp, FirebaseError, firebase } from '@nativescript/firebase-core';
import { MessagingCore } from '@nativescript/firebase-messaging-core';
let defaultMessaging;
const fb = firebase();
Object.defineProperty(fb, 'messaging', {
    value: () => {
        if (!defaultMessaging) {
            defaultMessaging = new Messaging();
        }
        return defaultMessaging;
    },
    writable: false,
});
export class Messaging {
    constructor() {
        _Messaging_native.set(this, void 0);
        _Messaging_app.set(this, void 0);
        _Messaging_onMessage.set(this, void 0);
        _Messaging_onNotificationTap.set(this, void 0);
        _Messaging_onToken.set(this, void 0);
        _Messaging_instance.set(this, void 0);
        if (defaultMessaging) {
            return defaultMessaging;
        }
        defaultMessaging = this;
        __classPrivateFieldSet(this, _Messaging_instance, MessagingCore.getInstance(), "f");
    }
    getToken() {
        return new Promise((resolve, reject) => {
            org.nativescript.firebase.messaging.FirebaseMessaging.getToken(this.native, new org.nativescript.firebase.messaging.FirebaseMessaging.Callback({
                onSuccess(result) {
                    resolve(result);
                },
                onError(error) {
                    reject(FirebaseError.fromNative(error));
                },
            }));
        });
    }
    getAPNSToken() {
        return null;
    }
    hasPermission() {
        return __classPrivateFieldGet(this, _Messaging_instance, "f").hasPermission();
    }
    onMessage(listener) {
        if (!listener && __classPrivateFieldGet(this, _Messaging_onMessage, "f")) {
            __classPrivateFieldGet(this, _Messaging_instance, "f").removeOnMessage(__classPrivateFieldGet(this, _Messaging_onMessage, "f"));
        }
        else {
            __classPrivateFieldGet(this, _Messaging_instance, "f").addOnMessage(listener);
        }
        __classPrivateFieldSet(this, _Messaging_onMessage, listener, "f");
    }
    onNotificationTap(listener) {
        if (!listener && __classPrivateFieldGet(this, _Messaging_onNotificationTap, "f")) {
            __classPrivateFieldGet(this, _Messaging_instance, "f").removeOnNotificationTap(__classPrivateFieldGet(this, _Messaging_onNotificationTap, "f"));
        }
        else {
            __classPrivateFieldGet(this, _Messaging_instance, "f").addOnNotificationTap(listener);
        }
        __classPrivateFieldSet(this, _Messaging_onNotificationTap, listener, "f");
    }
    onToken(listener) {
        if (!listener && __classPrivateFieldGet(this, _Messaging_onToken, "f")) {
            __classPrivateFieldGet(this, _Messaging_instance, "f").removeOnToken(__classPrivateFieldGet(this, _Messaging_onToken, "f"));
        }
        else {
            __classPrivateFieldGet(this, _Messaging_instance, "f").addOnToken(listener);
        }
        __classPrivateFieldSet(this, _Messaging_onToken, listener, "f");
    }
    registerDeviceForRemoteMessages() {
        return Promise.resolve();
    }
    requestPermission(permissions) {
        return __classPrivateFieldGet(this, _Messaging_instance, "f").requestPermission(permissions);
    }
    subscribeToTopic(topic) {
        return new Promise((resolve, reject) => {
            org.nativescript.firebase.messaging.FirebaseMessaging.subscribeToTopic(topic, this.native, new org.nativescript.firebase.messaging.FirebaseMessaging.Callback({
                onSuccess(result) {
                    resolve();
                },
                onError(error) {
                    reject(FirebaseError.fromNative(error));
                },
            }));
        });
    }
    unregisterDeviceForRemoteMessages() {
        return Promise.resolve();
    }
    unsubscribeFromTopic(topic) {
        return new Promise((resolve, reject) => {
            org.nativescript.firebase.messaging.FirebaseMessaging.unsubscribeFromTopic(topic, this.native, new org.nativescript.firebase.messaging.FirebaseMessaging.Callback({
                onSuccess(result) {
                    resolve();
                },
                onError(error) {
                    reject(FirebaseError.fromNative(error));
                },
            }));
        });
    }
    deleteToken() {
        return new Promise((resolve, reject) => {
            org.nativescript.firebase.messaging.FirebaseMessaging.deleteToken(this.native, new org.nativescript.firebase.messaging.FirebaseMessaging.Callback({
                onSuccess(result) {
                    resolve();
                },
                onError(error) {
                    reject(FirebaseError.fromNative(error));
                },
            }));
        });
    }
    get isDeviceRegisteredForRemoteMessages() {
        return org.nativescript.firebase.messaging.FirebaseMessaging.hasPermission(Utils.android.getApplicationContext());
    }
    get autoInitEnabled() {
        var _a, _b;
        return (_b = (_a = this.native) === null || _a === void 0 ? void 0 : _a.isAutoInitEnabled) === null || _b === void 0 ? void 0 : _b.call(_a);
    }
    set autoInitEnabled(value) {
        var _a, _b;
        (_b = (_a = this.native) === null || _a === void 0 ? void 0 : _a.setAutoInitEnabled) === null || _b === void 0 ? void 0 : _b.call(_a, value);
    }
    get app() {
        if (!__classPrivateFieldGet(this, _Messaging_app, "f")) {
            // @ts-ignore
            __classPrivateFieldSet(this, _Messaging_app, FirebaseApp.fromNative(FIRApp.defaultApp()), "f");
        }
        return __classPrivateFieldGet(this, _Messaging_app, "f");
    }
    get native() {
        if (!__classPrivateFieldGet(this, _Messaging_native, "f")) {
            __classPrivateFieldSet(this, _Messaging_native, com.google.firebase.messaging.FirebaseMessaging.getInstance(), "f");
        }
        return __classPrivateFieldGet(this, _Messaging_native, "f");
    }
    get android() {
        return this.native;
    }
}
_Messaging_native = new WeakMap(), _Messaging_app = new WeakMap(), _Messaging_onMessage = new WeakMap(), _Messaging_onNotificationTap = new WeakMap(), _Messaging_onToken = new WeakMap(), _Messaging_instance = new WeakMap();
//# sourceMappingURL=index.android.js.map